"use strict";
function getScriptMap() {
    // store the versions of the HERE API
    var apiVersion = "v3";
    var codeVersion = "3.0";
    // the base url for all scripts from the API
    var baseUrl = "//js.api.here.com/" +
        (apiVersion + "/" + codeVersion);
    // core code
    var coreScript = baseUrl + "/mapsjs-core.js";
    // service code
    var serviceScript = baseUrl + "/mapsjs-service.js";
    // default ui code
    var uiScript = baseUrl + "/mapsjs-ui.js";
    // map events (pan, scroll wheel zoom) code
    var mapEventsScript = baseUrl + "/mapsjs-mapevents.js";
    // return an array with all script names within
    return {
        coreScript: coreScript,
        serviceScript: serviceScript,
        uiScript: uiScript,
        mapEventsScript: mapEventsScript
    };
}
exports.getScriptMap = getScriptMap;
exports.__esModule = true;
exports["default"] = getScriptMap;
